require("timestamp");

include("bot.lua");

config = include("config.lua");

local debugging = true;

function macro.init()
	bot = Bot(config);
	bot:connect(config.server, config.port);
end

local running = true;
function macro.main(dt)
	if( not running ) then
		return false;
	end

	bot:run();
	return true;
end

function macro.event(e, ...)
	if( e == "socketreceived" ) then
		if( debugging ) then
			print("[DEBUG EVENT]", e .. "\r\n", ...);
		end

		-- Pass socket messages on to the IRC bot
		if( e == "socketreceived" ) then
			bot:recv(...);
		end
	end

	if( e == "keypressed" and window.getFocusHwnd() == window.getAppHwnd() ) then
		local vk,toggle = ...;

		if( vk == key.VK_Q ) then
			print("Quit hotkey pressed. Quitting at your request!");
			bot:quit();
			running = false;
		end
	end
end